/*********************************************************************
 * TP2, info528 (mathématiques pour l'informatique)
 * correction d'erreurs dans les QR codes
 * automne 2012
 * L3-STIC info
 *
 * étudiant : Vizir Iznogood
 ********************************************************************/

/* voir le fichier qrcodes.h pour des commentaires sur l'utilisation des
 * fonctions */
#include "./qrcodes.h"


/**********
 * format *
 **********/

/* syndrome pour le format */
void format_syndrome(const bit F[15], bit S[10]) {
  /* le syndrome du format est le reste de la division du polynome F par le
   * polynome générateur G = X^10 + X^8 + X^5 + X^4 + X^2 + X + 1 */
  bit G[11] = { 1,0,1,0,0,1,1,0,1,1,1 };
  bit current_rest[15];
  int i,k ;
  for (i=0; i<15; i++) current_rest[i] = F[i] ;

  //printf("On divise "); print_bits_polynomial(F, 14);
  //printf("par "); print_bits_polynomial(G,10);
  for (k=0; k<5; k++) {
      if (current_rest[k] == 1) {
          for (i=k; i<11+k; i++) current_rest[i] ^= G[i-k];
      }
  }
  //printf("et on obtient un current_rest de "); print_bits_polynomial(current_rest,14);
  for (i=0; i<10; i++) S[i] = current_rest[i+5];
}

/* encode un format (5 bits), sans appliquer le masque */
void encode_format(const bit format_data[5], bit F[15]) {
    int i;
    bit tmp[15];
    bit syndrome[10];
    for (i=0; i<5; i++) tmp[i] = format_data[i];
    for (i=5; i<15; i++) tmp[i] = 0;
    format_syndrome(tmp, syndrome);

    //print_bits_array(format_data, 5); print_bits_polynomial(format_data, 4);
    //print_bits_array(syndrome, 11); print_bits_polynomial(syndrome, 10);
    for (i=0; i<5; i++) F[i] = format_data[i];
    for (i=5; i<15; i++) F[i] = syndrome[i-5];
    //print_bits_array(F, 15); print_bits_polynomial(F, 14);
}

/* distance de Hamming entre deux tableaux de bits */
int hamming_format(bit *F1, bit *F2, int n) {
    int d = 0;
    int i;
    for (i=0; i<n; i++) if (F1[i] != F2[i]) d++;
    return(d);
}

/* corrige le format (15 bits) en cherchant parmis tous les formats valides,
 * celui qui est le plus proche du format donné en argument.
 * Si c'est possible, le format est modifié, et la valeur de retour est égale
 * au nombre de bits modifiés.
 * Si ce n'est pas possible, le format n'est pas modifié, et la valeur de
 * retour est -1. */
int correct_format(bit F[15]) {
  int i;
  bit tmp_format[15];
  int format_data_int;    /* format, as an integer between 0 and 32 */
  bit format_data[5];     /* format, as an array of 5 bits */

  for (format_data_int=0; format_data_int<32; format_data_int++) {
    format_data[0] = (format_data_int & (1<<4))>>4;
    format_data[1] = (format_data_int & (1<<3))>>3;
    format_data[2] = (format_data_int & (1<<2))>>2;
    format_data[3] = (format_data_int & (1<<1))>>1;
    format_data[4] = format_data_int & 1;
    encode_format(format_data, tmp_format);
    /*
     * À COMPLÉTER
     */
  }
  return -1;
}



/*****************************************
 * Correction d'erreurs dans les données *
 *****************************************/


/*********************
 ** Pivot de Gauss ***
 *********************/

/* pivot de Gauss, en place, pour résoudre un système d'équations linéaires
 * S'il y a une solution unique, elle est mise dans dans "X" et la fonction
 * renvoie 0.
 * Sinon, elle renvoie -1. */
int solve_linear_system(int height, int width, byte **M, byte *X) {
  /*
   * À COMPLÉTER
   */
  return 0;
}

/* évalue un polynome P de degré d sur une valeur x avec la méthode de Horner
 * Attention, les coefficients de poids fort sont au début du tableau */
byte eval_poly(const byte *P, int d, byte x) {
  /*
   * À COMPLÉTER
   */
  return 0;
}

/* calcul des syndromes pour les octets de données */
void data_syndrome(const byte *data, int n, byte *S) {
  /*
   * À COMPLÉTER
   */
}

/* calcul des coefficients du polynome localisateur d'erreurs.
 *   - S contient les syndromes
 *   - le résultat (coefficients du polynome localisateur) est mis dans L
 * La valeur de retour correspond au nombre d'erreurs trouvées. */
int error_locator(int nb_correction_bytes, const byte *S, byte *L) {
  /*
   * À COMPLÉTER
   */
  return -1;
}



/* cherche la localisation des erreurs en cherchant les zeros du polynome de
 * localisation.
 *   - L contient le polynome de localisation
 *   - le résultat est stocké dans X
 * La valeur de retour est le nombre d'erreurs localisées. */
int find_locations(int nb_errors, const byte *L, byte *X) {
  /*
   * À COMPLÉTER
   */
  return -1;
}


/* calcul des valeurs d'erreurs en résolvant un système linéaire
 *   - S contient les syndromes
 *   - X contient la matrice des ?????
 *   - le résultat est mis dans V
 * La valeur de retour est 0 si la résolution a donné une unique solution, et
 * -1 sinon. */
int error_values(int nb_correction_bytes, int nb_errors, const byte *S, const byte *X, byte *V) {
  /*
   * À COMPLÉTER
   */
  return 0;
}


/* corrige (si c'est possible) les octets de données */
int correct_data(byte *data, int correction_level) {
  /*
   * À COMPLÉTER
   */
  return 0;
}

/* vim: set tabstop=2 shiftwidth=2 : */
